/*****************************************************************************/

/*
 *      ns2ktvgui_cb.h -- REALmagic NS200TV setting application
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Pascal Cannenterre <pascal_cannenterre@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __NS2KTVGUI_CB_H__
#define __NS2KTVGUI_CB_H__

#include <gtk/gtk.h>
#include <gdk/gdktypes.h>

void Save_clicked		         ( GtkWidget *widget, gpointer   data );
void Cancel_clicked	                 ( GtkWidget *widget, gpointer   data );
void Reset_clicked                       ( GtkWidget *widget, gpointer   data );

void position_left_pressed               ( GtkWidget *widget, gpointer   data );
void position_right_pressed		 ( GtkWidget *widget, gpointer   data );
void position_down_pressed		 ( GtkWidget *widget, gpointer   data );
void position_up_pressed		 ( GtkWidget *widget, gpointer   data );

void size_venlarge_pressed	         ( GtkWidget *widget, gpointer   data );
void size_henlarge_pressed	         ( GtkWidget *widget, gpointer   data );
void size_vreduce_pressed	         ( GtkWidget *widget, gpointer   data );
void size_hreduce_pressed	         ( GtkWidget *widget, gpointer   data );

void switch_TVstandard_cb                ( GtkWidget *widget, gpointer   data );        
void switch_TVoutput_mode_cb             ( GtkWidget *widget, gpointer   data );
void switch_Scart_RF_cb                  ( GtkWidget *widget, gpointer   data );

void brightness_changed                  ( GtkAdjustment *adj,gpointer   data );
void contrast_changed                    ( GtkAdjustment *adj,gpointer   data );
void saturation_changed                  ( GtkAdjustment *adj,gpointer   data );
void sharpness_changed                   ( GtkAdjustment *adj,gpointer   data );
void flicker_changed                     ( GtkAdjustment *adj,gpointer   data );

void refresh_BSCShFl_frame_cb            ( GtkWidget *widget);
void refresh_TV_standard_frame_cb        ( GtkWidget *widget);
void refresh_Output_Mode_frame_cb        ( GtkWidget *widget);
void refresh_Scart_RF_frame_cb           ( GtkWidget *widget);
void refresh_all_cb                      ( GtkWidget *widget, gpointer   data);

#endif /* ns2ktvgui_cb */
