/*****************************************************************************/

/*
 *      configurationCB.h -- REALmagic calibration application 
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __CONFIGURATIONCB_H__
#define __CONFIGURATIONCB_H__

#include <gtk/gtk.h>

void AdjustBorder_clicked   ( GtkWidget *widget,gpointer   data );
void AutoCalibration_clicked( GtkWidget *widget,gpointer   data );
void ResetDefaults_clicked  ( GtkWidget *widget,gpointer   data );
void Advanced_clicked       ( GtkWidget *widget,gpointer   data );
void C_Ok_clicked           ( GtkWidget *widget,gpointer   data );

void volume_changed    ( GtkAdjustment *volume, GtkAdjustment *balance);
void balance_changed   ( GtkAdjustment *balance, GtkAdjustment *volume);
void brightness_changed( GtkAdjustment *adj,gpointer   data );
void contrast_changed  ( GtkAdjustment *adj,gpointer   data );
void saturation_changed( GtkAdjustment *adj,gpointer   data );

void loadconfig				 (GtkWidget *widget);
void updateAudio       (int volume, int balance);

#endif /* CONFIGURATIONCB */
