/*****************************************************************************/
/*
 *      interface.h -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2001 Sigma Designs
 *                    written by Pascal Cannenterre <pascal_cannenterre@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#include "optionswin.h"
#include "dvdoptionswin.h"
#include "keypad.h"
#include "playlist.h"
#ifdef _VOD_
#include "rtspwin.h"
#endif

typedef enum _GuiControlElement_
{
  TOOLBAR,
  SLIDER,
  KEYPAD,
  STATUSBAR,
  PLAYLIST
}GuiControlElement;


void my_gtk_widget_destroy(GtkWidget ** );

void set_window_icon(GtkWidget *, char **);
GtkWidget* create_pixmap(GtkWidget *, char **);

GtkWidget* create_window (void);

GtkWidget *get_display_bar(GtkWidget *, GtkWidget *);
GtkWidget *get_toolbar (GtkWidget * , GtkWidget * );
GtkWidget *get_seek_bar (GtkWidget *, GtkWidget * );

GtkWidget *xpm_button ( GtkWidget * , gchar     * );

void get_file_selector ( GtkWidget  * );

void get_main_menu ( GtkWidget  * , GtkWidget ** );

void gtk_message_box ( gchar * , gchar * , gchar * , gboolean, GtkSignalFunc, gpointer);
void gtk_quick_question_box(gchar * window_title, gchar * frame_title, gchar * msg, GtkSignalFunc, gpointer);

gboolean gtk_destroy_file_selector(GtkWidget *, gpointer);
gboolean gtk_destroy_message_box(GtkWidget *, gpointer);

#endif /* INTERFACE */
