/*****************************************************************************/
/*
 *      remote.h -- REALmagic remote control client os independent headers
 *
 *      Copyright (C) 1999-2001 Sigma Designs
 *                   written by Julien Veyssiere
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*****************************************************************************/

#ifndef __REMOTE_H__
#define __REMOTE_H__

#define VGA_TV   118 //'v'
#define L_R      120 //'x'
#define MUTE     104 //'h'
#define VOL_MORE  43 //'+'
#define VOL_LESS  45 //'-'
#define ENT       10 //ENTER

#define COMPUTER 113 //'q'
#define PLAYER   105 //'i'

#define UP    28 //Up arrow
#define DOWN  29 //Down arrow
#define RIGHT 30 //Right arrow
#define LEFT  31 //Left arrow
#define SEL   32 //SPACE	

#define MENU     109 //'m'
#define TITLE    116 //'t'
#define OSD      111 //'o'
#define LANGUAGE 108 //'l'
#define ANGLE    97  //'a'
#define SUBTITLE 122 //'z'

#define PLAY_PAUSE 112 //'p'
#define STOP_1     115 //'s'
#define STEP_PLAY  121 //'y'
#define EJECT      101 //'e'
#define EJECT1     123 //"{"
#define REW        119 //'w'
#define FF         102 //'f'
#define LAST_TRACK  8  //Backspace
#define NEXT_TRACK  9  //Tab
#define SOFT_POWER 103 //'g'
#define RS232C     125 //'}'
#define DEF        46  //'.'
#define BREAK      98  //'b'
#define TIME_ADJUST 99 //'c'

#define ZERO  48
#define ONE   49
#define TWO   50
#define THREE 51
#define FOUR  52
#define FIVE  53
#define SIX   54
#define SEVEN 55
#define EIGHT 56
#define NINE  57

// Function defined in remote.c
void ReadLibrary(INFO *Info);


// OS dependent functions in linuxremote.c
PORTHANDLE	OSOpenPort(const char *);
BOOL		OSClosePort(PORTHANDLE);     
int		OSReadPort(INFO *);
void		OSPurge(PORTHANDLE);
BOOL start_listening_to_remote(INFO *);
void spawnRemoteListener(INFO *);
void stopRemoteListener(INFO *);
void GetSymbol(INFO *Info);

#endif /* __REMOTE_H__ */
